#!/usr/bin/perl
# 
# library - extra cms 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.01;
	# 
	# ver 0.00 [2004/08/20] 
	# ver 0.01 [2004/08/29] ץ饰λͤѹ
	# --[ѤƤ륰Хѿ]-------------------------------
	# @gTemp         : ƥץ졼ƤǼ(֥åʬ¸)
	# %gData         : Ǽ => $gData{}[֥åֹ]
	# $gEnv{'block'} : ֥åɽ => $gEnv{'block'}{֥å}
	# -------------------------------------------------------------
	require 'sbtext.pl';
	require 'sbtime.pl';
}
sub sbcms_amazon {
	if ($gData{'num'}{'aws'}) { # ᾦ
		my @order = @{$gData{'aws'}};
		my $num = 0;
		@order = sort { $$b{'mod'} <=> $$a{'mod'} } @order;
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ƥФ
			$gData{'{amazon_ProductName}'}[$num]    = $$hash{'name'};
			$gData{'{amazon_Catalog}'}[$num]        = $$hash{'cat'};
			$gData{'{amazon_Creator}'}[$num]        = &sbtxt_lfconv($$hash{'cre'},2);
			$gData{'{amazon_ReleaseDate}'}[$num]    = $$hash{'date'};
			$gData{'{amazon_Manufacturer}'}[$num]   = $$hash{'make'};
			$gData{'{amazon_ImageUrlSmall}'}[$num]  = $$hash{'ism'};
			$gData{'{amazon_ImageUrlMedium}'}[$num] = $$hash{'imd'};
			$gData{'{amazon_ImageUrlLarge}'}[$num]  = $$hash{'ilg'};
			$gData{'{amazon_Availability}'}[$num]   = $$hash{'ava'};
			$gData{'{amazon_ListPrice}'}[$num]      = $$hash{'lpr'};
			$gData{'{amazon_OurPrice}'}[$num]       = $$hash{'opr'};
			$gData{'{amazon_comment}'}[$num]        = &sbtxt_lfconv($$hash{'msg'},2);
			$gData{'{amazon_url}'}[$num]            = $$hash{'url'};
			$gData{'{amazon_item}'}[$num]  = '<div class="amazon">' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<a href="' . $$hash{'url'} . '" target="_blank">';
			$gData{'{amazon_item}'}[$num] .= '<img border="0" src="' . $$hash{'imd'} . '" alt="' . $$hash{'name'} . '" class="amazon_pict" /></a>' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<div class="amazon_text">' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<a href="' . $$hash{'url'} . '" target="_blank"><strong>' . $$hash{'name'} . '</strong></a><br />' . "\n";
			$gData{'{amazon_item}'}[$num] .= $$hash{'make'} . '<br />' . &sbtxt_lfconv($$hash{'msg'},2) . '</div>' . "\n" . '</div>' . "\n";
			$num++;
			last if ($num == $gEnv{'conf'}{'aws_disp'});
		}
		$gEnv{'block'}{'amazon'} = $num;
	}
}
sub sbcms_calendar {
	my $month = shift;
	$month = &sbtime_stamp($gNowTime,'%yr%mo',$gEnv{'conf'}{'timezone'},'en') if ($month eq '');
	my $yr = substr($month,0,4);
	my $mo = substr($month,4,2);
	my $wk = &sbtime_weekday($yr,$mo,1); # 
	my $ed = &sbtime_lastday($yr,$mo);
	my $td = &sbtime_stamp($gNowTime,'%yr%mo%dy',$gEnv{'conf'}{'timezone'},'en');
	my %ent = ();
	my %cal = {'tab'=>'','hor'=>'','ver'=>''};
	{ # ȥ꡼н
		use Time::Local;
		my $chk_st = timelocal(0,0,0,1,($mo-1),$yr);
		my $chk_ed = timelocal(59,59,23,$ed,($mo-1),$yr);
		foreach my $hash ( @{$gData{'ent'}} ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼
			next if ($$hash{'date'} < $chk_st);
			next if ($$hash{'date'} > $chk_ed);
			$ent{&sbtime_stamp($$hash{'date'},'%yr%mo%dy',$gEnv{'conf'}{'timezone'},'en')} = 1;
		}
	}
	my $pr = ($mo != 1)  ? $yr . &sbtime_pad0($mo - 1) : ($yr - 1) . '12';
	my $nx = ($mo != 12) ? $yr . &sbtime_pad0($mo + 1) : ($yr + 1) . '01';
	$pr = '<a href="' . &sbcms_monthlylink($pr) . '">&lt;&lt;</a>';
	$nx = '<a href="' . &sbcms_monthlylink($nx) . '">&gt;&gt;</a>';
	{ # ǽν
		$gData{'{calendar}'}[0] = '<table border="0" cellspacing="0" cellpadding="0" class="calendar">' . "\n";
		$gData{'{calendar2}'}[0]  = '<table border="0" cellspacing="0" cellpadding="0" class="calendar">' . "\n";
		$gData{'{calendar2}'}[0] .= '<tr>' . "\n" . '<td colspan="7" class="calendar_month">' . $pr . ' ';
		$gData{'{calendar2}'}[0] .= &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . ' ' . $nx . '</td>' . "\n" . '</tr>' . "\n";
		$gData{'{calendar2}'}[0] .= '<td class="weekday">Sun</td><td class="weekday">Mon</td><td class="weekday">Tue</td><td class="weekday">Wed</td>';
		$gData{'{calendar2}'}[0] .= '<td class="weekday">Thu</td><td class="weekday">Fri</td><td class="weekday">Sat</td></tr>' . "\n";
		$gData{'{calendar_vertical}'}[0] = '<br />' . "\n" . $mo . '<br />' . "\n" . '--<br />' . "\n";
		$gData{'{calendar_horizontal}'}[0] = $pr . ' <span class="calendar_month">' . &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . '</span> | ';
	}
	for (my $d=1;$d<=$ed;$d++) { # 
		my $w = ($d - 1 + $wk) % 7;
		my $check = $month . &sbtime_pad0($d);
		$cal{'tab'} .= '<tr>' if ($d == 1 or ($w == 0 and $d > 1));
		$cal{'tab'} .= ('<td class="cell">&nbsp;</td>' x $w) if ($d == 1 and $w > 0);
		$cal{'tab'} .= '<td class="cell">';
		if ($ent{$check}) {
			$cal{'tab'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
			$cal{'hor'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
			$cal{'ver'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
		}
		{ # ɽ
			$cal{'tab'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
			$cal{'hor'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
			$cal{'ver'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
		}
		if ($ent{$check}) {
			$cal{'tab'} .= '</a>';
			$cal{'hor'} .= '</a>';
			$cal{'ver'} .= '</a>';
		}
		$cal{'tab'} .= '</td>';
		$cal{'hor'} .= ' ';
		$cal{'ver'} .= '<br />' . "\n";
		$cal{'tab'} .= ('<td class="cell">&nbsp;</td>' x (6 - $w)) if ($d == $ed);
		$cal{'tab'} .= '</tr>' . "\n" if ($d == $ed or $w == 6);
	}
	{ # Ǹν
		$gData{'{calendar}'}[0] .= $cal{'tab'} . '<td colspan="7"><div style="text-align: center;" class="calendar_month">';
		$gData{'{calendar}'}[0] .= $pr .  ' ' . &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . ' ' . $nx . '</div></td></tr>' . "\n" . '</table>' . "\n";
		$gData{'{calendar2}'}[0] .= $cal{'tab'} . '</table>';
		$gData{'{calendar_vertical}'}[0] .= $cal{'ver'} . '--<br />' . "\n" . $nx . '<br />' . "\n";
		$gData{'{calendar_vertical}'}[0] .= $pr . '<br />' . "\n" . '--<br />' . "\n";
		$gData{'{calendar_horizontal}'}[0] .= $cal{'hor'} . $nx . "\n";
	}
	$gEnv{'block'}{'calendar'} = 1;
	return();
}
sub sbcms_search_entry {
	my ($eid,$text) = @_;
	my $flag = 0;
	&sbfile_read_entry($eid);
	my $data = $gData{'entry'}{$eid}{'ent'};
	my $subj = $$data{'subj'};
	my $body = &sbtxt_lfconv(&sbtxt_det($$data{'body'}),1);
	my $more = &sbtxt_lfconv(&sbtxt_det($$data{'more'}),1);
	$body =~ tr/\n//d;
	$more =~ tr/\n//d;
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($subj,$text) : (index($subj,$text) > -1);
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($body,$text) : (index($body,$text) > -1) if (!$flag);
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($more,$text) : (index($more,$text) > -1) if (!$flag and $more ne '');
	delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
	return($flag);
}
1;
