#!/usr/bin/perl
# 
# library - counter utility 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.06;
	# 
	# ver 0.00 [2004/07/01] 
	# ver 0.01 [2004/07/12] ǡեΥѥΥХ
	# ver 0.02 [2004/07/21] ߽Υѥեޥ󥹲
	# ver 0.03 [2004/07/29] ᥤ롼ܿ
	# ver 0.04 [2004/08/03] 롼ѹ
	# ver 0.05 [2004/08/18] ץ饰б
	# ver 0.06 [2004/08/20] ǡɹߥ롼㴳ѹ
	&sbcnt_main();
}

sub sbcnt_main {
	my $mode = &sbcnt_init($gEnv{'basic'}{'init'});         # ˺
	my $flag = &sbcnt_readcookie($gEnv{'basic'}{'logtag'}); # åǧƤƤ
	eval {
		my $count = &sbcnt_recordlog($flag,$mode); # Ͽޤ (by ̥)
		if ($mode eq 'gif' or $mode eq 'js') {
			print &sbcnt_httphead($mode);                # HTTP HEAD 
			&sbcnt_dispimage() if ($mode eq 'gif');      # ɽ㤦
			&sbcnt_dispcount($count) if ($mode eq 'js'); # ɽ㤦
		} else {
			die($gMsg{'error'}{'unknown'}); # ġꤨʤ
		}
	};
	&sbtmp_error($@) if ($@); # ʤ󤫥ޥȤǤ硩
	return();
}
sub sbcnt_init { # 
	my $file = shift; # ϥѥ᡼
	my $mode = '';    # ϥѥ᡼
	require 'sbtime.pl';
	require 'sbtext.pl';
	require 'sbform.pl';
	require 'sblock.pl';
	require 'sbhtml.pl';
	require 'sbfile.pl';
	$gLockFile = 'cnt';
	eval {
		&sbini_read_globalconf($file);
		{ # Ķɹ
			my $conf = $gEnv{dir}{data} . $gEnv{file}{conf} . $gEnv{file}{suf};
			open(CONF,"<$conf") or die("failed opening configure file.\n");
			while (my $line = <CONF>) {
				$line =~ tr/\x0D\x0A//d;
				my ($key,$val) = split("\t",$line,2);
				next if ($key eq '');
				$gEnv{'conf'}{$key} = $val;
			}
			close(CONF);
		}
		foreach my $conf ( keys(%{$gEnv{file}}) ) {
			next if (index($gEnv{file}{$conf},'.') > -1);
			$gEnv{file}{$conf} .= $gEnv{file}{suf};
		}
		# ǡȿ
		require 'sblang.pl';
		$gEnv{dir}{base} = $gEnv{conf}{dir_base};
		$gEnv{dir}{log}  = $gEnv{conf}{dir_log};
		$gEnv{dir}{img}  = $gEnv{conf}{dir_img};
		$gEnv{srv}{base} = $gEnv{conf}{srv_base};
		&sbform_read();
		$mode = ($gIn{'disp'} eq 'on') ? 'js' : 'gif';
		&sbini_load_plugin('cnt');
	};
	if ($@) {
		print "Content-Type: text/html;\n\n";
		die("<pre>" . $@ . "</pre>\n");
	}
	return($mode);
}
sub sbcnt_recordlog { # Ͽɹ
	my ($flag,$mode) = @_; # ϥѥ᡼
	my $count = 0;         # ϥѥ᡼
	my $file = $gEnv{'dir'}{'data'} . $gEnv{'file'}{'log'};
	if ($mode eq 'js') {
		open(LOGIN,"<$file");
		my $line = <LOGIN>;
		close(LOGIN);
		$count = (split('<>',$line))[0];
	} else {
		my $lfile = &sblock_lock() or die($gMsg{'error'}{'file_lock'} . "\n");
		eval {
			my $bgn = $gNowTime - ( $gEnv{'basic'}{'checklog'} * 24 * 3600 );
			my $tmp = '';
			my $check = 0;
			my @env = &sbhtml_gethost(); # $host,$addr,$refe,$agnt
			my @buf = ();
			open(CNTLOG,"+<$file");
			eval{ # flock ʻ
				flock(CNTLOG, 2);
			};
			$tmp = <CNTLOG>;
			while (my $line = <CNTLOG>) {
				push(@buf,$line) if (int($line) >= $bgn);
			}
			$tmp =~ tr/\x0D\x0A//d;
			($count,$tmp,$check) = split('<>',$tmp,3);
			$count = int($count);
			truncate(CNTLOG, 0);
			seek(CNTLOG, 0, 0);
			if ($flag ne 'on') { # Ͽ
				unshift(@buf,"$gNowTime<>$env[1]<>$env[0]<>$env[2]<>$env[3]<>$gIn{'href'}<>$gIn{'refe'}<>\n");
				$count++ if ($tmp ne $env[1]);
			}
			print CNTLOG $count,'<>',$env[1],'<>',$gNowTime,"\n";
			print CNTLOG @buf;
			close(CNTLOG);
		};
		die($@ . "\n") if ($@);
		&sblock_unlock($lfile);
	}
	return(int($count));
}
sub sbcnt_httphead { # HTTP HEADɽ
	my $mode = shift; # ϥѥ᡼
	my ($out) = ();   # ϥѥ᡼
	$out .= 'Content-Type: text/javascript' . "\n" if ($mode eq 'js');
	$out .= 'Content-type: image/gif' . "\n" if ($mode eq 'gif');
	$out .= 'Content-Type: text/html' . "\n" if ($mode ne 'js' and $mode ne 'gif');
	$out .= 'Pragma: no-cache' . "\n";
	$out .= 'Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0' . "\n";
	$out .= 'Expires: ' . &sbtime_stamp($gNowTime - 100,'%wk, %Dy-%MO-%yr %hr:%mi:%sc GMT','+0000','en') . "\n";
	$out .= "\n"; # إåȥܥǥζڤ
	return($out);
}
sub sbcnt_readcookie { # åɹ
	my $name = shift; # ϥѥ᡼
	my (%eating,@cookies,%cookie_base) = (); # ѥ᡼
	@cookies = split(/;/,$ENV{'HTTP_COOKIE'});
	foreach (@cookies) {
		my ($cook_key,$cook_val) = split(/=/,$_);
		$cook_key =~ s/ //g;
		$cookie_base{$cook_key} = $cook_val;
	}
	@cookies = split(/,/,$cookie_base{$name});
	foreach (@cookies) {
		my ($cook_key,$cook_val) = split('<>',$_);
		$eating{$cook_key} = $cook_val;
	}
	return($eating{$name});
}
sub sbcnt_dispimage { # ߡ᡼
	my @dmy = (
		'47','49','46','38','39','61','02','00','02','00','80','00','00','00','00',
		'00','ff','ff','ff','21','f9','04','01','00','00','01','00','2c','00','00',
		'00','00','02','00','02','00','00','02','02','8c','53','00','3b'
	);
	binmode(STDOUT);
	foreach (@dmy) {
		my $data = pack('C*',hex($_));
		print $data;
	}
	return();
}
sub sbcnt_dispcount { # ɽ
	my $count = shift;
	$count =~ tr/\x0D\x0A//d;
	print 'document.write("',$count,'");',"\n";
	return();
}
1;
