#!/usr/bin/perl
# 
# library - util 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.05;
	# 
	# ver 0.00 [2004/05/19] 
	# ver 0.01 [2004/05/24] Ѵѹ(sbtime_convtime Ѥ褦)
	# ver 0.02 [2004/05/24] 桼Ͽѹ
	# ver 0.03 [2004/07/19] Ф˥桼͡बϤʤХ / ɹ߻ν㴳
	# ver 0.04 [2004/07/22] MT ɹ߻ΥХ
	# ver 0.05 [2004/08/18] ΤΤʤȡȥåХåɹߡФʤ褦
	require 'sbtext.pl';
	require 'sbfile.pl';
	require 'sbtime.pl';
}

sub sbutil_import {
	my ($data,$uri) = @_; # ϥѥ᡼
	my $num = 0; # ϥѥ᡼
	my $xml = 0;
	if ($data eq '' and $uri ne '') {
		$uri = &sbtxt_uridec($uri);
		if ($uri =~ /jugem\.cc\/?$/ and $uri =~ /^http:\/\//) {
			chop($uri) if ($uri =~ /\/$/);
			$uri .= '/?mode=xml';
			my $ua = &sbini_agent();
			my $response = $ua->get($uri);
			if ( ${$response}{'_rc'} eq '200' and ${$response}{'_msg'} =~ /ok/i ) {
				$data = ${$response}{'_content'};
			} else {
				die('error during connection');
			}
		} else {
			die($uri . ' is not Jugem site.');
		}
	} elsif ($data eq '') {
		die('&quot;uri&quot; or &quot;data file&quot; is required.');
	}
	$xml = 1 if ($data =~ /^<\?xml /);
	die($gMsg{'error'}{'unknown'}) if ($gData{'num'}{'user'} < 1); # 桼ǡɤ߹ޤƤʤ
	foreach my $type ('ent','com','tb','cat') {
		&sbfile_read_datafile($type);
	}
	$num = ($xml) ? &sbutil_import_xml($data) : &sbutil_import_txt($data);
	foreach my $type ('ent','com','tb','cat','user') {
		&sbfile_update_datafile($type);
	}
	return($num);
}
sub sbutil_import_xml {
	my $xml = shift;
	my $num = $gData{'num'}{'ent'};
	$xml = &sblang_conv($xml,$gEnv{'code'},'utf8') if ($gEnv{'code'} ne 'utf8');
	$xml =~ s/\x0D\x0A/\n/g;
	$xml =~ tr/\x0D\x0A/\n\n/;
	$xml = &sbtxt_remove_cdata($xml);
	use XML::Parser::Lite;
	my $parser = new XML::Parser::Lite;
	$parser->setHandlers(
		Init  => \&sbjgm_logInit,
		Final => \&sbjgm_logFinal,
		Start => \&sbjgm_logStart,
		Char  => \&sbjgm_logChar,
		End   => \&sbjgm_logEnd,
	);
	$parser->parse($xml);
	return($gData{'num'}{'ent'} - $num);
}
sub sbjgm_logConv {
	my ($eid,$id,$type,$num) = @_;
	my $sbtype = 'ent';
	$sbtype = 'com' if ($type eq 'comments');
	$sbtype = 'tb' if ($type eq 'trackbacks');
	for (my $i=0;$i<=$num;$i++) {
		if ($sbtype eq 'ent') {
			my $cat = &sbjgm_logCatConv($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'category'});
			my $auth = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'author'};
			my $body = &sbtxt_restore_cdata($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'description'});
			my $more = &sbtxt_restore_cdata($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'sequel'});
			my $sum  = &sbtxt_restore_cdata($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'excerpt'});
			my $stat = $gData{'import'}->{'buf'}->{$id}->{'entry'}->{$i}->{'status'};
			my $acm  = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'allowcomments'};
			my $atb  = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'allowpings'};
			my $form = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'convertbreaks'};
			&sbini_creat_newcat($cat);
			if ($gIn{'import_user'} eq 'on') {
				$auth = $gEnv{'currentuser'};
			} else {
				$auth = &sbutil_adduser($auth) if ($auth ne $gData{'user'}[$gEnv{'currentuser'}]{'real'});
				$auth = $gEnv{'currentuser'} if ($auth eq $gData{'user'}[$gEnv{'currentuser'}]{'real'});
			}
			$gData{'entry'}{$eid}{$sbtype}{'id'}   = $eid;
			$gData{'entry'}{$eid}{$sbtype}{'wid'}  = 0;
			$gData{'entry'}{$eid}{$sbtype}{'subj'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'title'};
			$gData{'entry'}{$eid}{$sbtype}{'cat'}  = $cat;
			$gData{'entry'}{$eid}{$sbtype}{'date'} = &sbjgm_logDateConv($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'date'});
			$gData{'entry'}{$eid}{$sbtype}{'auth'} = $auth;
			$gData{'entry'}{$eid}{$sbtype}{'edit'} = $auth;
			$gData{'entry'}{$eid}{$sbtype}{'stat'} = ($stat eq 'Publish' or $stat eq '') ? 1 : 0;
			$gData{'entry'}{$eid}{$sbtype}{'com'}  = $gData{'import'}->{'buf'}->{$id}->{'cnum'} + 1;
			$gData{'entry'}{$eid}{$sbtype}{'tb'}   = $gData{'import'}->{'buf'}->{$id}->{'tnum'} + 1;
			$gData{'entry'}{$eid}{$sbtype}{'acm'}  = ($acm eq '') ? 1 : $acm;
			$gData{'entry'}{$eid}{$sbtype}{'atb'}  = ($atb eq '') ? 1 : $atb;
			$gData{'entry'}{$eid}{$sbtype}{'form'} = ($form eq '') ? 0 : $form;
			$gData{'entry'}{$eid}{$sbtype}{'ping'} = '';
			$gData{'entry'}{$eid}{$sbtype}{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
			$gData{'entry'}{$eid}{$sbtype}{'more'} = &sbtxt_lfconv(&sbtxt_ent($more),0);
			$gData{'entry'}{$eid}{$sbtype}{'sum'}  = &sbtxt_lfconv(&sbtxt_ent($sum),0);
		} elsif ($sbtype eq 'com') {
			my $mid = $gData{'num'}{'com'};
			my $body = &sbtxt_restore_cdata($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'description'});
			$body =~ s/<br \/>//g;
			if ($body ne '') {
				$gData{'entry'}{$eid}{$sbtype}[$i]{'id'}   = $mid;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'wid'}  = 0;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'eid'}  = $eid;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'stat'} = 1;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'date'} = &sbjgm_logDateConv($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'date'});
				$gData{'entry'}{$eid}{$sbtype}[$i]{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
				$gData{'entry'}{$eid}{$sbtype}[$i]{'agnt'} = '';
				$gData{'entry'}{$eid}{$sbtype}[$i]{'auth'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'name'};
				$gData{'entry'}{$eid}{$sbtype}[$i]{'host'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'host'};
				$gData{'entry'}{$eid}{$sbtype}[$i]{'mail'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'email'};
				$gData{'entry'}{$eid}{$sbtype}[$i]{'url'}  = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'url'};
				&sbini_creat_newcomment($eid,
				                        $gData{'entry'}{$eid}{$sbtype}[$i]{'stat'},
				                        $gData{'entry'}{$eid}{$sbtype}[$i]{'date'},
				                        $gData{'entry'}{$eid}{$sbtype}[$i]{'auth'},
				                        $gData{'entry'}{$eid}{$sbtype}[$i]{'host'});
			}
		} elsif ($sbtype eq 'tb') {
			my $bid = $gData{'num'}{'tb'};
			my $body = &sbtxt_restore_cdata($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'excerpt'});
			my $url  = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'url'};
			if ($url ne '') {
				$gData{'entry'}{$eid}{$sbtype}[$i]{'id'}   = $bid;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'wid'}  = 0;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'eid'}  = $eid;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'stat'} = 1;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'date'} = &sbjgm_logDateConv($gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'date'});
				$gData{'entry'}{$eid}{$sbtype}[$i]{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
				$gData{'entry'}{$eid}{$sbtype}[$i]{'subj'} = $subj;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'name'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'blog_name'};
				$gData{'entry'}{$eid}{$sbtype}[$i]{'url'}  = $url;
				$gData{'entry'}{$eid}{$sbtype}[$i]{'host'} = $gData{'import'}->{'buf'}->{$id}->{$type}->{$i}->{'host'};
				&sbini_creat_newtb($eid,
				                   $gData{'entry'}{$eid}{$sbtype}[$i]{'stat'},
				                   $gData{'entry'}{$eid}{$sbtype}[$i]{'date'},
				                   $gData{'entry'}{$eid}{$sbtype}[$i]{'subj'},
				                   $gData{'entry'}{$eid}{$sbtype}[$i]{'name'},
				                   $gData{'entry'}{$eid}{$sbtype}[$i]{'url'});
			}
		}
	}
	return();
}
sub sbjgm_logDateConv {
	my $text = shift;
	if ($text =~ /(\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/) {
		$text = &sbtime_convtime($6,$5,$4,$3,$2,$1,'+0900');
	} else {
		$text = $gNowTime;
	}
	return($text);
}
sub sbjgm_logCatConv {
	my $text = shift;
	$text = (split('##',$text,2))[1] if (index($text,'##') > -1);
	return($text);
}
sub sbjgm_logInit {
	my $self = shift;
	$gData{'import'}->{'tagname'} = '';
	$gData{'import'}->{'flag'} = 0;
	$gData{'import'}->{'stat'} = '';
	$gData{'import'}->{'buf'} = {};
	$gData{'import'}->{'eid'} = -1;
	$gData{'import'}->{'newuser'} = [];
}
sub sbjgm_logFinal {
	my $self = shift;
	for (my $i=0;$i<=$gData{'import'}->{'eid'};$i++) {
		my $eid = $gData{'num'}{'ent'};
		&sbjgm_logConv($eid,$i,'entry',0);
		&sbjgm_logConv($eid,$i,'comments',$gData{'import'}->{'buf'}->{$i}->{'cnum'}) if ($gData{'import'}->{'buf'}->{$i}->{'cnum'} > -1);
		&sbjgm_logConv($eid,$i,'trackbacks',$gData{'import'}->{'buf'}->{$i}->{'tnum'}) if ($gData{'import'}->{'buf'}->{$i}->{'tnum'} > -1);
		&sbfile_update_entry($eid);
		&sbini_creat_newentry($gData{'entry'}{$eid}{'ent'}{'subj'},
		                      $gData{'entry'}{$eid}{'ent'}{'cat'},
		                      $gData{'entry'}{$eid}{'ent'}{'date'},
		                      $gData{'entry'}{$eid}{'ent'}{'auth'},
		                      $gData{'entry'}{$eid}{'ent'}{'stat'},
		                      $gData{'entry'}{$eid}{'ent'}{'com'},
		                      $gData{'entry'}{$eid}{'ent'}{'tb'});
	}
	return();
}
sub sbjgm_logStart {
	my $self = shift;
	my $name = shift;
	$gData{'import'}->{'tagname'} = $name;
	if ($gData{'import'}->{'tagname'} eq 'entries') {
		$gData{'import'}->{'flag'} = 1;
	} elsif ($gData{'import'}->{'tagname'} eq 'entry') {
		if ($gData{'import'}->{'flag'}) {
			$gData{'import'}->{'eid'}++;
			$gData{'import'}->{'stat'} = $gData{'import'}->{'tagname'};
			$gData{'import'}->{'buf'}->{$gData{'import'}->{'eid'}} = {};
			$gData{'import'}->{'buf'}->{$gData{'import'}->{'eid'}}->{'cnum'} = -1;
			$gData{'import'}->{'buf'}->{$gData{'import'}->{'eid'}}->{'tnum'} = -1;
		}
	} elsif ($gData{'import'}->{'tagname'} eq 'comments') {
		$gData{'import'}->{'stat'} = $gData{'import'}->{'tagname'} if ($gData{'import'}->{'flag'} and $gData{'import'}->{'eid'} > -1);
	} elsif ($gData{'import'}->{'tagname'} eq 'comment') {
		$gData{'import'}->{'buf'}->{$gData{'import'}->{'eid'}}->{'cnum'}++ if ($gData{'import'}->{'stat'} eq 'comments');
	} elsif ($gData{'import'}->{'tagname'} eq 'trackbacks') {
		$gData{'import'}->{'stat'} = $gData{'import'}->{'tagname'} if ($gData{'import'}->{'flag'} and $gData{'import'}->{'eid'} > -1);
	} elsif ($gData{'import'}->{'tagname'} eq 'trackback') {
		$gData{'import'}->{'buf'}->{$gData{'import'}->{'eid'}}->{'tnum'}++ if ($gData{'import'}->{'stat'} eq 'trackbacks');
	}
}
sub sbjgm_logChar {
	my $self = shift;
	my $name = shift;
	if ($gData{'import'}->{'flag'} and $gData{'import'}->{'tagname'}) {
		my $num  = 0;
		my $stat = $gData{'import'}->{'stat'};
		my $eid  = $gData{'import'}->{'eid'};
		$num = ($stat eq 'comments') ? $gData{'import'}->{'buf'}->{$eid}->{'cnum'} : $gData{'import'}->{'buf'}->{$eid}->{'tnum'} if ($stat ne 'entry');
		$gData{'import'}->{'buf'}->{$eid}->{$stat}->{$num}->{$gData{'import'}->{'tagname'}} = $name;
	}
}
sub sbjgm_logEnd {
	my $self = shift;
	my $name = shift;
	if ($name eq 'entries') {
		$gData{'import'}->{'flag'} = 0;
	} elsif ($name eq 'entry') {
	} elsif ($name eq 'comments') {
	} elsif ($name eq 'comment') {
	} elsif ($name eq 'trackbacks') {
	} elsif ($name eq 'trackback') {
	}
	$gData{'import'}->{'tagname'} = '';
}
sub sbutil_import_txt {
	my $text = shift;
	my $num = $gData{'num'}{'ent'};
	my $aLogSep = ('-' x 8);
	my $aSubSep = ('-' x 5);
	$gData{'import'} = [];
	$text =~ s/\x0D\x0A/\n/g;
	$text =~ tr/\x0D\x0A/\n\n/;
	$text = &sblang_conv($text,$gEnv{'code'});
	foreach my $entry (split("\n$aLogSep\n",$text)) { # ȥ꡼
		next if (!$entry);
		my %elem = ();
		my ($meta,@elements) = split(/^$aSubSep/m,$entry);
		my ($comnum,$tb_num) = (0,0);
		foreach my $line (split("\n",$meta)) {
			next if(!$line);
			$line =~ s/^\s*//;
			$line =~ s/\s*$//;
			my ($key,$val) = split(/\s*:\s*/,$line,2);
			if ($key eq 'AUTHOR') {
				$elem{'author'} = $val;
			} elsif ($key eq 'PRIMARY CATEGORY') {
				$elem{'category'} = $val;
			} elsif ($key eq 'TITLE') {
				$elem{'title'} = $val;
			} elsif ($key eq 'DATE') {
				$elem{'date'} = &sbmt_logDateConv($val);
			} elsif ($key eq 'STATUS') {
				$elem{'status'} = $val;
			} elsif ($key eq 'ALLOW COMMENTS') {
				$elem{'alcom'} = $val;
			} elsif ($key eq 'ALLOW PINGS') {
				$elem{'alping'} = $val;
			} elsif ($key eq 'CONVERT BREAKS') {
				$elem{'format'} = $val;
			}
		}
		foreach my $element (@elements) {
			$element =~ s/^\s*//;
			$element =~ s/\s*$//;
			if ($element =~ s/^BODY:\n//) {
				$elem{'body'} = $element;
			} elsif ($element =~ s/^EXTENDED BODY:\n//) {
				$elem{'sequel'} = $element;
			} elsif ($element =~ s/^EXCERPT:\n//) {
				$elem{'excerpt'} = $element;
			} elsif ($element =~ s/^KEYWORDS:\n//) {
				$elem{'keyword'} = $element;
			} elsif ($element =~ s/^COMMENT:\n//) {
				$elem{'com'} = [] if (!$comnum);
				$elem{'com'}[$comnum] = {};
				my @lines = split("\n",$element);
				my ($i,$idx) = (0,0);
				READ_COM: foreach my $line (@lines) {
					$line =~ s/^\s*//;
					my ($key,$val) = split(/\s*:\s*/,$line,2);
					if ($key eq 'AUTHOR') {
						$elem{'com'}[$comnum]{'name'} = $val;
					} elsif ($key eq 'EMAIL') {
						$elem{'com'}[$comnum]{'mail'} = $val;
					} elsif ($key eq 'URL') {
						$elem{'com'}[$comnum]{'link'} = $val;
					} elsif ($key eq 'IP') {
						$elem{'com'}[$comnum]{'host'} = $val;
					} elsif ($key eq 'DATE') {
						$elem{'com'}[$comnum]{'date'} = &sbmt_logDateConv($val);
					} else {
						$idx = $i;
						last READ_COM;
					}
					$i++;
				}
				$elem{'com'}[$comnum]{'body'} = join("<br />\n", @lines[$idx..$#lines]);
				$comnum++;
			} elsif ($element =~ s/^PING:\n//) {
				$elem{'tb'} = [] if (!$tb_num);
				$elem{'tb'}[$tb_num] = {};
				my @lines = split("\n",$element);
				my ($i,$idx) = (0,0);
				READ_TB: foreach my $line (@lines) {
					$line =~ s/^\s*//;
					my ($key,$val) = split(/\s*:\s*/,$line,2);
					if ($key eq 'TITLE') {
						$elem{'tb'}[$tb_num]{'subj'} = $val;
					} elsif ($key eq 'URL') {
						$elem{'tb'}[$tb_num]{'link'} = $val;
					} elsif ($key eq 'IP') {
						$elem{'tb'}[$tb_num]{'host'} = $val;
					} elsif ($key eq 'BLOG NAME') {
						$elem{'tb'}[$tb_num]{'name'} = $val;
					} elsif ($key eq 'DATE') {
						$elem{'tb'}[$tb_num]{'date'} = &sbmt_logDateConv($val);
					} else {
						$idx = $i;
						last READ_TB;
					}
					$i++;
				}
				$elem{'tb'}[$tb_num]{'body'} = join("\n", @lines[$idx..$#lines]);
				$tb_num++;
			}
		}
		my $eid = $gData{'num'}{'ent'};
		&sbmt_logConv($eid,\%elem,$comnum,$tb_num);
		&sbfile_update_entry($eid);
		&sbini_creat_newentry($gData{'entry'}{$eid}{'ent'}{'subj'},
		                      $gData{'entry'}{$eid}{'ent'}{'cat'},
		                      $gData{'entry'}{$eid}{'ent'}{'date'},
		                      $gData{'entry'}{$eid}{'ent'}{'auth'},
		                      $gData{'entry'}{$eid}{'ent'}{'stat'},
		                      $gData{'entry'}{$eid}{'ent'}{'com'},
		                      $gData{'entry'}{$eid}{'ent'}{'tb'});
	}
	return($gData{'num'}{'ent'} - $num);
}
sub sbmt_logConv {
	my ($eid,$hash,$com,$tb) = @_;
	my %entry = %$hash;
	MT_ENTRY: {
		my $cat  = $entry{'category'};
		my $auth = $entry{'author'};
		my $body = $entry{'body'};
		my $more = $entry{'sequel'};
		my $sum  = $entry{'excerpt'};
		&sbini_creat_newcat($cat);
		if ($gIn{'import_user'} eq 'on') {
			$auth = $gEnv{'currentuser'};
		} else {
			$auth = &sbutil_adduser($auth) if ($auth ne $gData{'user'}[$gEnv{'currentuser'}]{'real'});
			$auth = $gEnv{'currentuser'} if ($auth eq $gData{'user'}[$gEnv{'currentuser'}]{'real'});
		}
		$gData{'entry'}{$eid}{'ent'}{'id'}   = $eid;
		$gData{'entry'}{$eid}{'ent'}{'wid'}  = 0;
		$gData{'entry'}{$eid}{'ent'}{'subj'} = $entry{'title'};
		$gData{'entry'}{$eid}{'ent'}{'cat'}  = $cat;
		$gData{'entry'}{$eid}{'ent'}{'date'} = $entry{'date'};
		$gData{'entry'}{$eid}{'ent'}{'auth'} = $auth;
		$gData{'entry'}{$eid}{'ent'}{'edit'} = $auth;
		$gData{'entry'}{$eid}{'ent'}{'stat'} = ($entry{'status'} eq 'Publish') ? 1 : 0;
		$gData{'entry'}{$eid}{'ent'}{'com'}  = $com;
		$gData{'entry'}{$eid}{'ent'}{'tb'}   = $tb;
		$gData{'entry'}{$eid}{'ent'}{'acm'}  = $entry{'alcom'};
		$gData{'entry'}{$eid}{'ent'}{'atb'}  = $entry{'alping'};
		$gData{'entry'}{$eid}{'ent'}{'form'} = $entry{'format'};
		$gData{'entry'}{$eid}{'ent'}{'ping'} = '';
		$gData{'entry'}{$eid}{'ent'}{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
		$gData{'entry'}{$eid}{'ent'}{'more'} = &sbtxt_lfconv(&sbtxt_ent($more),0);
		$gData{'entry'}{$eid}{'ent'}{'sum'}  = &sbtxt_lfconv(&sbtxt_ent($sum),0);
	} # end of MT_ENTRY
	MT_COM: {
		for (my $i=0;$i<$com;$i++) {
			my $mid  = $gData{'num'}{'com'};
			my $body = $entry{'com'}[$i]{'body'};
			if ($body ne '') {
				$gData{'entry'}{$eid}{'com'}[$i]{'id'}   = $mid;
				$gData{'entry'}{$eid}{'com'}[$i]{'wid'}  = 0;
				$gData{'entry'}{$eid}{'com'}[$i]{'eid'}  = $eid;
				$gData{'entry'}{$eid}{'com'}[$i]{'stat'} = 1;
				$gData{'entry'}{$eid}{'com'}[$i]{'date'} = $entry{'com'}[$i]{'date'};
				$gData{'entry'}{$eid}{'com'}[$i]{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
				$gData{'entry'}{$eid}{'com'}[$i]{'agnt'} = '';
				$gData{'entry'}{$eid}{'com'}[$i]{'auth'} = $entry{'com'}[$i]{'name'};
				$gData{'entry'}{$eid}{'com'}[$i]{'host'} = $entry{'com'}[$i]{'host'};
				$gData{'entry'}{$eid}{'com'}[$i]{'mail'} = $entry{'com'}[$i]{'mail'};
				$gData{'entry'}{$eid}{'com'}[$i]{'url'}  = $entry{'com'}[$i]{'link'};
				&sbini_creat_newcomment($eid,
				                        $gData{'entry'}{$eid}{'com'}[$i]{'stat'},
				                        $gData{'entry'}{$eid}{'com'}[$i]{'date'},
				                        $gData{'entry'}{$eid}{'com'}[$i]{'auth'},
				                        $gData{'entry'}{$eid}{'com'}[$i]{'host'});
			}
		}
	} # end of MT_COM
	MT_TB: {
		for (my $i=0;$i<$tb;$i++) {
			my $bid  = $gData{'num'}{'tb'};
			my $body = $entry{'tb'}[$i]{'body'};
			my $url  = $entry{'tb'}[$i]{'link'};
			if ($url ne '') {
				$gData{'entry'}{$eid}{'tb'}[$i]{'id'}   = $bid;
				$gData{'entry'}{$eid}{'tb'}[$i]{'wid'}  = 0;
				$gData{'entry'}{$eid}{'tb'}[$i]{'eid'}  = $eid;
				$gData{'entry'}{$eid}{'tb'}[$i]{'stat'} = 1;
				$gData{'entry'}{$eid}{'tb'}[$i]{'date'} = $entry{'tb'}[$i]{'date'};
				$gData{'entry'}{$eid}{'tb'}[$i]{'body'} = &sbtxt_lfconv(&sbtxt_ent($body),0);
				$gData{'entry'}{$eid}{'tb'}[$i]{'subj'} = $entry{'tb'}[$i]{'subj'};
				$gData{'entry'}{$eid}{'tb'}[$i]{'name'} = $entry{'tb'}[$i]{'name'};
				$gData{'entry'}{$eid}{'tb'}[$i]{'url'}  = $url;
				$gData{'entry'}{$eid}{'tb'}[$i]{'host'} = $entry{'tb'}[$i]{'host'};
				&sbini_creat_newtb($eid,
				                   $gData{'entry'}{$eid}{'tb'}[$i]{'stat'},
				                   $gData{'entry'}{$eid}{'tb'}[$i]{'date'},
				                   $gData{'entry'}{$eid}{'tb'}[$i]{'subj'},
				                   $gData{'entry'}{$eid}{'tb'}[$i]{'name'},
				                   $gData{'entry'}{$eid}{'tb'}[$i]{'url'});
			}
		}
	} # end of MT_TB
	return();
}
sub sbmt_logDateConv {
	my $text = shift;
	if ($text =~ /(\d\d)\/(\d\d)\/(\d\d\d\d) (\d\d)\:(\d\d)\:(\d\d) (\w\w)/) {
		my $ho = $4;
		my $mm = $6;
		$ho += 12 if ($mm eq 'PM' and $ho < 12);
		$text = &sbtime_convtime($6,$5,$ho,$2,$1,$3,'+0000');
	} else {
		$text = $gNowTime;
	}
	return($text);
}
sub sbutil_adduser {
	my $user = shift;
	my $flag = -1;
	for (my $i=0;$i<$gData{'num'}{'user'};$i++) {
		next if ($gData{'user'}[$i]{'id'} eq '');
		next if ($user ne $gData{'user'}[$i]{'real'});
		$flag = $gData{'user'}[$i]{'id'};
	}
	if ($flag > -1) {
		return($flag);
	} else {
		my $name = ($user =~ /^\w+$/) ? $user : 'user' . $gData{'num'}{'user'};
		&sbini_creat_newuser($name,$gIn{'import_pass'},$gIn{'import_pass'},'',2,$user);
		return($gData{'num'}{'user'});
	}
}
sub sbutil_export {
	&sbfile_read_datafile('ent');
	print 'Content-type: application/xml;charset=utf-8',"\n\n";
	print &sbutil_export_head();
	for (my $i=0;$i<$gData{'num'}{'ent'};$i++) {
		next if ($gData{'ent'}[$i]{'id'} eq '');
		&sbfile_read_entry($gData{'ent'}[$i]{'id'});
		print &sbutil_export_body($gData{'ent'}[$i]{'id'});
	}
	print &sbutil_export_foot();
	exit(0);
}
sub sbutil_export_body {
	my ($eid) = @_;
	my $output = '';
	my $date   = &sbtime_stamp($gData{'entry'}{$eid}{'ent'}{'date'},'%yr/%mo/%dy %hr:%mi:%sc',$gEnv{'conf'}{'timezone'},'en');
	my $status = ($gData{'entry'}{$eid}{'ent'}{'stat'}) ? 'Publish' : 'Draft';
	my $author = $gData{'entry'}{$eid}{'ent'}{'auth'};
	my $body   = $gData{'entry'}{$eid}{'ent'}{'body'};
	my $more   = $gData{'entry'}{$eid}{'ent'}{'more'};
	$body = ($gData{'entry'}{$eid}{'ent'}{'form'} == 1) ? &sbtxt_lfconv(&sbtxt_det($body),2) : &sbtxt_lfconv(&sbtxt_det($body),1);
	$more = ($gData{'entry'}{$eid}{'ent'}{'form'} == 1) ? &sbtxt_lfconv(&sbtxt_det($more),2) : &sbtxt_lfconv(&sbtxt_det($more),1);
	$author = 0 if ($gData{'user'}[$author]{'id'} eq '');
	$author = ($gData{'user'}[$author]{'real'} eq '') ? $gData{'user'}[$author]{'name'} : $gData{'user'}[$author]{'real'};
	$output .= <<"_XML_ENTRY_";
	<entry>
		<title>$gData{'entry'}{$eid}{'ent'}{'subj'}</title>
		<author>$author</author>
		<category>$gData{'entry'}{$eid}{'ent'}{'cat'}</category>
		<status>$status</status>
		<allowcomments>$gData{'entry'}{$eid}{'ent'}{'acm'}</allowcomments>
		<allowpings>$gData{'entry'}{$eid}{'ent'}{'atb'}</allowpings>
		<convertbreaks>$gData{'entry'}{$eid}{'ent'}{'form'}</convertbreaks>
		<date>$date</date>
		<excerpt>$gData{'entry'}{$eid}{'ent'}{'sum'}</excerpt>
		<keyword />
		<description><!\[CDATA\[$body\]\]></description>
		<sequel><!\[CDATA\[$more\]\]></sequel>
_XML_ENTRY_
	$output .= "\t\t" . '<comments>' . "\n";
	for (my $i=0;$i<$gData{'entry'}{$eid}{'ent'}{'com'};$i++) {
		my $date = &sbtime_stamp($gData{'entry'}{$eid}{'com'}[$i]{'date'},'%yr/%mo/%dy %hr:%mi:%sc',$gEnv{'conf'}{'timezone'},'en');
		my $body = $gData{'entry'}{$eid}{'com'}[$i]{'body'};
		$body = &sbtxt_lfconv($body,2);
		next if ($body eq '');
		$output .= <<"_XML_COMMENT_";
			<comment>
				<title />
				<description><!\[CDATA\[$body\]\]></description>
				<name>$gData{'entry'}{$eid}{'com'}[$i]{'auth'}</name>
				<email>$gData{'entry'}{$eid}{'com'}[$i]{'mail'}</email>
				<url>$gData{'entry'}{$eid}{'com'}[$i]{'url'}</url>
				<host>$gData{'entry'}{$eid}{'com'}[$i]{'host'}</host>
				<date>$date</date>
			</comment>
_XML_COMMENT_
	}
	$output .= "\t\t" . '</comments>' . "\n";
	$output .= "\t\t" . '<trackbacks>' . "\n";
	for (my $i=0;$i<$gData{'entry'}{$eid}{'ent'}{'tb'};$i++) {
		my $date = &sbtime_stamp($gData{'entry'}{$eid}{'tb'}[$i]{'date'},'%yr/%mo/%dy %hr:%mi:%sc',$gEnv{'conf'}{'timezone'},'en');
		my $body = $gData{'entry'}{$eid}{'tb'}[$i]{'body'};
		$body = &sbtxt_lfconv($body,1);
		next if ($gData{'entry'}{$eid}{'tb'}[$i]{'url'} eq '');
		$output .= <<"_XML_TRACKBACK_";
			<trackback>
				<title>$gData{'entry'}{$eid}{'tb'}[$i]{'subj'}</title>
				<excerpt><!\[CDATA\[$body\]\]></excerpt>
				<blog_name>$gData{'entry'}{$eid}{'tb'}[$i]{'name'}</blog_name>
				<host>$gData{'entry'}{$eid}{'tb'}[$i]{'host'}</host>
				<url>$gData{'entry'}{$eid}{'tb'}[$i]{'url'}</url> 
				<date>$date</date> 
			</trackback>
_XML_TRACKBACK_
	}
	$output .= "\t\t" . '</trackbacks>' . "\n";
	$output .= "\t" . '</entry>' . "\n";
	$output = &sblang_conv($output,'utf8',$gEnv{'code'});
	return($output);
}
sub sbutil_export_head {
	my $blog_name = $gEnv{'conf'}{'blog_title'};
	my $blog_desc = &sbtxt_lfconv(&sbtxt_det($gEnv{'conf'}{'blog_desc'}),1);
	$output .= <<"_XML_HEAD_";
<?xml version=\"1.0\" encoding=\"utf-8\"?>
<blog>
	<name>$blog_name</name> 
	<description><!\[CDATA\[$blog_desc\]\]></description>
_XML_HEAD_
	my %count;
	$output .= "\t" . '<users>' . "\n";
	for (my $i=0;$i<$gData{'num'}{'user'};$i++) {
		next if ($gData{'user'}[$i]{'id'} eq '');
		my $user_name = $gData{'user'}[$i]{'name'};
		my $user_real = $gData{'user'}[$i]{'real'};
		my $user_text = &sbtxt_lfconv(&sbtxt_det($gData{'user'}[$i]{'prof'}),1);
		$output .= <<"_XML_USER_";
		<user>
			<name>$user_name</name> 
			<full_name>$user_real</full_name> 
			<description><!\[CDATA\[$user_text\]\]></description> 
		</user>
_XML_USER_
	}
	$output .= "\t" . '</users>' . "\n";
	$output .= "\t" . '<entries>' . "\n";
	$output = &sblang_conv($output,'utf8',$gEnv{'code'});
	return($output);
}
sub sbutil_export_foot {
	my $output = <<"_XML_FOOT_";
	</entries>
</blog>
_XML_FOOT_
	return($output);
}
1;
